# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    url = "https://www.apple.com/itunes/download/"
    if control.architecture == "x64":
        download_url = url + "win64"
        bin_list = [
            "AppleApplicationSupport.msi",
            "AppleApplicationSupport64.msi",
            "AppleMobileDeviceSupport64.msi",
            "AppleSoftwareUpdate.msi",
            "Bonjour64.msi",
            "iTunes64.msi",
            "SetupAdmin.exe",
        ]

        bin_dependencies_to_install = [
            "AppleApplicationSupport.msi",
            "AppleApplicationSupport64.msi",
            "AppleMobileDeviceSupport.msi",
            "AppleMobileDeviceSupport64.msi",
            "Bonjour64.msi",
        ]
        bin_name = "iTunes64Setup.exe"
        bin_msi_name = "iTunes64.msi"
    else:
        download_url = url + "win32"
        bin_list = [
            "AppleApplicationSupport.msi",
            "AppleApplicationSupport64.msi",
            "AppleMobileDeviceSupport64.msi",
            "AppleSoftwareUpdate.msi",
            "Bonjour64.msi",
            "iTunes64.msi",
            "SetupAdmin.exe",
        ]
        bin_dependencies_to_install = [
            "AppleApplicationSupport.msi",
            "AppleApplicationSupport64.msi",
            "AppleMobileDeviceSupport.msi",
            "AppleMobileDeviceSupport64.msi",
            "Bonjour.msi",
        ]
        bin_name = "iTunesSetup.exe"
        bin_msi_name = "iTunes.msi"

    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    if not isfile(bin_name):
        print("Downloading " + bin_name)
        wget(download_url, bin_name, proxies=proxies)

        # Extracting binaries from iTunesSetup
        for binary in bin_list:
            if isfile(binary):
                remove_file(binary)
        for bin_in_dir in glob.glob(bin_name):
            unzip_with_7zip(bin_in_dir, ".")
    version = get_file_properties(bin_name)["ProductVersion"]
    print("Latest %s version is: %s" % (control.name, version))

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Removing unwanted binaries
    for binary in glob.glob("*.exe") + glob.glob("*.msi"):
        if binary not in bin_dependencies_to_install or binary == bin_name:
            if binary != bin_msi_name:
                print("Removing %s" % binary)
                remove_file(binary)

    # Validating or not update-package-sources
    return package_updated
